Index: /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.cpp	(revision 88549)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.cpp	(revision 88550)
@@ -208,4 +208,6 @@
     bool hasSelectedText() const;
     bool isFindInPageWidgetVisible() const;
+    void findNext();
+    void findPrevious();
 
 public slots:
@@ -291,4 +293,6 @@
     bool isFindInPageWidgetVisible() const;
     void toggleFindInPage(bool fTrigger);
+    void findNext();
+    void findPrevious();
 
 public slots:
@@ -632,4 +636,16 @@
         return m_pContentViewer->isFindInPageWidgetVisible();
     return false;
+}
+
+void UIHelpBrowserTab::findNext()
+{
+    if (m_pContentViewer)
+        return m_pContentViewer->sltSelectNextMatch();
+}
+
+void UIHelpBrowserTab::findPrevious()
+{
+    if (m_pContentViewer)
+        return m_pContentViewer->sltSelectPreviousMatch();
 }
 
@@ -704,5 +720,4 @@
                      m_pFindInPageAction);
     m_pFindInPageAction->setCheckable(true);
-    m_pFindInPageAction->setShortcut(QKeySequence::Find);
 
     connect(m_pHomeAction, &QAction::triggered, this, &UIHelpBrowserTab::sltHomeAction);
@@ -1083,4 +1098,18 @@
     if (pTab)
         pTab->sltFindInPageAction(fTrigger);
+}
+
+void UIHelpBrowserTabManager::findNext()
+{
+    UIHelpBrowserTab *pTab = qobject_cast<UIHelpBrowserTab*>(currentWidget());
+    if (pTab)
+        pTab->findNext();
+}
+
+void UIHelpBrowserTabManager::findPrevious()
+{
+    UIHelpBrowserTab *pTab = qobject_cast<UIHelpBrowserTab*>(currentWidget());
+    if (pTab)
+        pTab->findPrevious();
 }
 
@@ -1250,4 +1279,6 @@
     , m_pCopySelectedTextAction(0)
     , m_pFindInPageAction(0)
+    , m_pFindNextInPageAction(0)
+    , m_pFindPreviousInPageAction(0)
     , m_pZoomMenuAction(0)
     , m_fModelContentCreated(false)
@@ -1336,5 +1367,17 @@
     connect(m_pFindInPageAction, &QAction::triggered,
             this, &UIHelpBrowserWidget::sltFindInPage);
-    m_pFindInPageAction->setShortcut(QString("Ctrl+F"));
+    m_pFindInPageAction->setShortcut(QKeySequence::Find);
+
+    m_pFindNextInPageAction = new QAction(this);
+    m_pFindNextInPageAction->setEnabled(false);
+    connect(m_pFindNextInPageAction, &QAction::triggered,
+            this, &UIHelpBrowserWidget::sltFindNextInPage);
+    m_pFindNextInPageAction->setShortcut(QKeySequence::FindNext);
+
+    m_pFindPreviousInPageAction = new QAction(this);
+    m_pFindPreviousInPageAction->setEnabled(false);
+    connect(m_pFindPreviousInPageAction, &QAction::triggered,
+            this, &UIHelpBrowserWidget::sltFindPreviousInPage);
+    m_pFindPreviousInPageAction->setShortcut(QKeySequence::FindPrevious);
 
     m_pPrintAction = new QAction(this);
@@ -1505,4 +1548,8 @@
     if(m_pFindInPageAction)
         m_pEditMenu->addAction(m_pFindInPageAction);
+    if(m_pFindNextInPageAction)
+        m_pEditMenu->addAction(m_pFindNextInPageAction);
+    if(m_pFindPreviousInPageAction)
+        m_pEditMenu->addAction(m_pFindPreviousInPageAction);
 
     if (m_pZoomMenuAction)
@@ -1646,4 +1693,8 @@
     if (m_pFindInPageAction)
         m_pFindInPageAction->setText(tr("&Find in Page"));
+    if (m_pFindNextInPageAction)
+        m_pFindNextInPageAction->setText(tr("&Find Next"));
+    if (m_pFindPreviousInPageAction)
+        m_pFindPreviousInPageAction->setText(tr("&Find Previous"));
 }
 
@@ -1701,4 +1752,16 @@
 }
 
+void UIHelpBrowserWidget::sltFindNextInPage()
+{
+    if (m_pTabManager)
+        m_pTabManager->findNext();
+}
+
+void UIHelpBrowserWidget::sltFindPreviousInPage()
+{
+    if (m_pTabManager)
+        m_pTabManager->findPrevious();
+}
+
 void UIHelpBrowserWidget::sltCopyAvailableChanged(bool fAvailable)
 {
@@ -1715,4 +1778,9 @@
         m_pFindInPageAction->blockSignals(false);
     }
+    if (m_pFindNextInPageAction)
+        m_pFindNextInPageAction->setEnabled(fVisible);
+
+    if (m_pFindPreviousInPageAction)
+        m_pFindPreviousInPageAction->setEnabled(fVisible);
 }
 
@@ -1984,4 +2052,8 @@
         if (m_pFindInPageAction)
             m_pFindInPageAction->setChecked(m_pTabManager->isFindInPageWidgetVisible());
+        if (m_pFindNextInPageAction)
+            m_pFindNextInPageAction->setEnabled(m_pTabManager->isFindInPageWidgetVisible());
+        if (m_pFindPreviousInPageAction)
+            m_pFindPreviousInPageAction->setEnabled(m_pTabManager->isFindInPageWidgetVisible());
     }
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.h	(revision 88549)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpBrowserWidget.h	(revision 88550)
@@ -101,4 +101,6 @@
     void sltFindInPage(bool fChecked);
     void sltFindInPageWidgetVisibilityChanged(bool fVisible);
+    void sltFindNextInPage();
+    void sltFindPreviousInPage();
 
 private:
@@ -175,4 +177,6 @@
     QAction             *m_pCopySelectedTextAction;
     QAction             *m_pFindInPageAction;
+    QAction             *m_pFindNextInPageAction;
+    QAction             *m_pFindPreviousInPageAction;
     UIZoomMenuAction    *m_pZoomMenuAction;
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.h	(revision 88549)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/helpbrowser/UIHelpViewer.h	(revision 88550)
@@ -77,4 +77,9 @@
     void toggleFindInPageWidget(bool fVisible);
 
+public slots:
+
+    void sltSelectPreviousMatch();
+    void sltSelectNextMatch();
+
 protected:
 
@@ -97,6 +102,4 @@
     void sltFindWidgetDrag(const QPoint &delta);
     void sltFindInPageSearchTextChange(const QString &strSearchText);
-    void sltSelectPreviousMatch();
-    void sltSelectNextMatch();
     void sltToggleFindInPageWidget(bool fVisible);
     void sltCloseFindInPageWidget();